document.addEventListener('consent.ready', function(e) {
	giveConsentGoogleRezensionen(e.detail);
});
document.addEventListener('consent.updated', function(e) {
	giveConsentGoogleRezensionen(e.detail);
});
function giveConsentGoogleRezensionen(detail) {
	if (detail !== null && typeof detail.grez_consent_googlekundenrezensionen !== 'undefined') {
		CheckConsentGoogleRezensionen(detail, 'googlekundenrezensionen');
	}
}

function CheckConsentGoogleRezensionen(detail, service, dependencies = '') {
	if (eval('detail.grez_consent_' + service) === true) {
		if (dependencies == '') {
			$('head script[data-gc-cmp-id="' + service  + '"]').each(function (index) {
				if (!this.hasAttribute('data-dep-id')) {
					setTimeout (function(f){
						GoogleRezensionenAddScript(service, index, f, document.head, detail);
					}, 200, this);
				}
			});
			$('body script[data-gc-cmp-id="' + service  + '"]').each(function (index) {
				if (!this.hasAttribute('data-dep-id')) {
					setTimeout (function(f){
						GoogleRezensionenAddScript(service, index, f, document.body, detail);
					}, 200, this);
				}
			});
			console.log('Consent für ' + service  + ' gewährt');
		} else {
			$('head script[data-gc-cmp-id="' + service  + '"][data-dep-id="' + dependencies  + '"]').each(function (index) {
				setTimeout (function(f){
					GoogleRezensionenAddScript(service, index, f, document.head, detail);
				}, 200, this);
			});
			$('body script[data-gc-cmp-id="' + service  + '"][data-dep-id="' + dependencies  + '"]').each(function (index) {
				setTimeout (function(f){
					GoogleRezensionenAddScript(service, index, f, document.body, detail);
				}, 200, this);
			});
			console.log('Consent für ' + service  +  ' (dep ' + dependencies + ') gewährt');
		}
	} else {
		console.log('Consent für ' + service  + ' entzogen');
	}
}

function GoogleRezensionenAddScript(service, index, element, parent, detail) {
	var script = document.createElement("script");
	script.setAttribute("type", "text/javascript");
	script.async = true;
	script.defer = true;
	if (typeof $(element).attr('src') !== "undefined") {
		script.setAttribute("src", $(element).attr('src'));
	//	if (typeof $(element).attr('data-onload') !== "undefined") {
		//		//script.addEventListener('load', $(element).attr('data-onload'));
	//		script.onload = eval('window.onload = function() {' + $(element).attr('data-onload') + '};');
	//		console.log('loaded');
	//	}
	}
	//console.log($(element).text());
	//script.innerText =  $(element).text();
	setInnerHTML(script, $(element).text());
	script.setAttribute("data-gc-cmp-set-id", service);
	script.setAttribute("data-gc-consent-given", "true");
	if (element.hasAttribute('data-dependencies')) {
		script.addEventListener("load", function(event) {
			console.log(service + ': dependencies on src');
			CheckConsentGoogleRezensionen(detail, service, element.getAttribute('data-dependencies'));
		});
		if (!script.hasAttribute('src')) {
			console.log(service + ': dependencies without src');
			CheckConsentGoogleRezensionen(detail, service, element.getAttribute('data-dependencies'));
		}
	}
	element.parentNode.replaceChild(script, element);
}

var setInnerHTML = function(elm, html) {
  elm.innerHTML = html;
  Array.from(elm.querySelectorAll("script")).forEach( oldScript => {
    const newScript = document.createElement("script");
    Array.from(oldScript.attributes)
      .forEach( attr => newScript.setAttribute(attr.name, attr.value) );
    newScript.appendChild(document.createTextNode(oldScript.innerHTML));
    oldScript.parentNode.replaceChild(newScript, oldScript);
  });
}


